--- old/usr/src/cmd/zfs/zfs_main.c	Wed Oct 16 18:29:02 2013
+++ new/usr/src/cmd/zfs/zfs_main.c	Wed Oct 16 18:29:02 2013
@@ -782,6 +782,8 @@
 		zfs_prop_t resv_prop;
 		char *strval;
 		char msg[1024];
+		uint64_t volblocksize;
+		int ncopies;
 
 		if (p = strchr(argv[0], '/'))
 			*p = '\0';
@@ -804,7 +806,18 @@
 		    props, 0, NULL, msg)) == NULL)
 			goto error;
 
-		volsize = zvol_volsize_to_reservation(volsize, real_props);
+		if (nvlist_lookup_string(real_props,
+		    zfs_prop_to_name(ZFS_PROP_COPIES), &strval) == 0)
+			ncopies = atoi(strval);
+		else
+			ncopies = 1;
+		if (nvlist_lookup_uint64(real_props,
+		    zfs_prop_to_name(ZFS_PROP_VOLBLOCKSIZE),
+		    &volblocksize) != 0)
+			volblocksize = ZVOL_DEFAULT_BLOCKSIZE;
+
+		volsize = zvol_volsize_to_reservation(volsize,
+		    volblocksize, ncopies);
 		nvlist_free(real_props);
 
 		if (nvlist_lookup_string(props, zfs_prop_to_name(resv_prop),
